'Compilable Example:
#Compiler PBWin 10
#Compile Exe "gbsaylist.exe"
#Dim All
%Unicode=1
#Include "Win32API.inc"

#Resource Manifest, 1, "gbsaylist_files/xptheme.xml"
#Resource Icon, aaa, "gbsaylist_files/gbsaylist.ico"
#Resource Icon, nextitem, "gbsaylist_files/next.ico"
#Resource Icon, previousitem, "gbsaylist_files/previous.ico"
#Resource Icon, firstitem, "gbsaylist_files/first.ico"
#Resource Icon, lastitem, "gbsaylist_files/last.ico"
#Resource Icon, speak, "gbsaylist_files/play.ico"
#Resource Icon, currentx, "gbsaylist_files/current.ico"
#Resource Icon, stopspeaking, "gbsaylist_files/stop.ico"
#Resource Icon, settings, "gbsaylist_files/settings.ico"
#Resource Icon, Help, "gbsaylist_files/help.ico"
#Resource Icon, fonttype, "gbsaylist_files/font.ico"
#Resource Icon, paste, "gbsaylist_files/paste.ico"

$ver = "  v1.03"

%IDC_Toolbar  = 500
%IDC_Words    = 501
%IDC_StatusBar= 502
%IDC_Timer    = 503

%IDM_Cut      = 700
%IDM_Paste    = 701
%IDM_Copy     = 702
%IDM_Delete   = 703
%IDM_Clear    = 704
%IDM_SortA    = 705
%IDM_SortD    = 706
%IDM_Blanks   = 707
%IDM_Sep      = 708
%IDM_Create   = 709
%IDM_Case     = 710
%IDM_AutoSpeak= 711
%IDM_NotifyEnd = 712
%IDM_AutoClose = 713

%IDM_Numbers  = 800
%IDM_Dollars  = 801
%IDM_0        = 802
%IDM_2        = 803
%IDM_4        = 804
%IDM_6        = 805

%IDT_First    = 900
%IDT_Last     = 901
%IDT_Next     = 902
%IDT_Previous = 903
%IDT_Pause    = 904
%IDT_Stop     = 905
%IDT_Play     = 906
%IDT_Settings = 907
%IDT_Font     = 908
%IDT_Current  = 909
%IDT_Paste    = 910
%IDT_Help     = 911

Global hDlg,hContext,hPopupSettings,hFont,ghHook,hWords,hThread As Dword
Global OldProc, Delay, StopTalking,FontSize,FontAttr As Long
Global NotifyEnd,AutoSpeak,AutoClose,WordCount,CurrentLine, CaseSensitive As Long
Global AllowedChars,CurrentWord,UnitType,FontName As WStringZ*%Max_Path
Global Backup$

Function PBMain() As Long
   Local style&
   style& = %WS_Child Or %WS_Visible Or %ES_MultiLine Or %WS_VScroll Or %ES_AutoHScroll _
      Or %WS_HScroll Or %ES_AutoVScroll Or %ES_WantReturn Or %WS_TabStop Or %WS_ClipSiblings 'or %ES_NoHideSel
   Dialog New Pixels, 0, "gbSayList" + $ver ,300,300,200,200, %WS_OverlappedWindow To hDlg
   Dialog Set Icon hDlg, "aaa"
   Control Add TextBox, hDlg, %IDC_Words,"", 10,55,100,100, Style&, %WS_Ex_ClientEdge Or %WS_Ex_Left
   Control Handle hDlg, %IDC_Words To hWords
   Control Add Statusbar, hDlg, %IDC_StatusBar, "",0,0,0,0
   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local w,h,iResult As Long, temp$, P As ToolTipText Ptr, nmtb As TBNotify Ptr, rc As Rect
   Select Case Cb.Msg
      Case %WM_InitDialog
         BuildAcceleratorTable
         CreateToolbar
         CreateContextMenu
         OldProc = SetWindowLong(hWords, %GWL_WndProc, CodePtr(NewProc))  'subclass
         Settings_INI "get"
         Font New FontName, FontSize, FontAttr To hFont
         Control Set Font hDlg, %IDC_Words, hFont
         If (Command$ <> "") And IsFile(Command$) Then
            LoadFile Command$
         Else
            LoadFile Exe.Path$ + "gbsaylist_wordlist.txt"
         End If
         Control Set Focus hDlg, %IDC_Words
         SetMenuStatus
         SetStatusBar
         PostMessage hWords, %EM_SETSEL, -1, 0   'remove highlighting on startup
         If AutoSpeak Then PostMessage(hDlg, %WM_User+1000, 0, 0)

      Case %WM_User+1000
         Thread Create SayList(0) To hThread   '0 not used

      Case %WM_Timer
         Thread Status hThread To iResult
         If AutoClose And (iResult<>&H103) Then Dialog End hDlg

      Case %WM_Destroy
         SetWindowLong hWords, %GWL_WNDPROC, OldProc   'un-subclass
         SaveSession
         Settings_INI "save"
         KillTimer hDlg, %IDC_Timer

      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDM_Cut     : SendMessage GetFocus, %WM_CUT, 0, 0     : SetStatusBar
            Case %IDM_Copy    : SendMessage GetFocus, %WM_COPY, 0, 0
            Case %IDM_Paste,%IDT_Paste   : SendMessage GetFocus, %WM_PASTE, 0, 0   : SetStatusBar
            Case %IDM_Delete  : SendMessage GetFocus, %WM_CLEAR, 0, 0   : SetStatusBar
            Case %IDM_Clear   : SendMessage GetFocus, %WM_SetText, 0, 0 : SetStatusBar
            Case %IDM_Blanks  : RemoveBlanks    : SetStatusBar
            Case %IDM_Create  : CreateWordList  : SetStatusBar
            Case %IDM_SortA   : SortWordList 1  '1=ascending
            Case %IDM_SortD   : SortWordList 0  '0=descending

            Case %IDM_Case      : CaseSensitive = CaseSensitive Xor 1 : SetMenuStatus
            Case %IDM_AutoSpeak : AutoSpeak = AutoSpeak Xor 1 : SetMenuStatus
            Case %IDM_AutoClose : AutoClose = AutoClose Xor 1 : SetMenuStatus
            Case %IDM_NotifyEnd : NotifyEnd = NotifyEnd Xor 1 : SetMenuStatus

            Case %IDM_Numbers : UnitType = "Numbers" : SetMenuStatus
            Case %IDM_Dollars : UnitType = "Dollars" : SetMenuStatus

            Case %IDM_0, %IDT_Settings : Delay = 0    : SetMenuStatus
            Case %IDM_2 : Delay = 2000 : SetMenuStatus
            Case %IDM_4 : Delay = 4000 : SetMenuStatus
            Case %IDM_6 : Delay = 6000 : SetMenuStatus

            Case %IDT_Play
               StopTalking = 0
               SetStatusBar
               Thread Create SayList(0) To hThread   '0 not used
               If AutoClose Then SetTimer(hDlg, %IDC_Timer, 250&, %NULL)

            Case %IDT_Stop
               StopTalking = 1
               SetStatusBar

            Case %IDT_First
               StopTalking = 0
               CurrentLine = 0
               Highlight CurrentLine
               SetStatusBar
               SayText((CurrentWord))

            Case %IDT_Next
               If CurrentLine = WordCount Then
                  SayText "No next word."
               Else
                  StopTalking = 0
                  Incr CurrentLine
                  Highlight CurrentLine
                  SetStatusBar
                  SayText((CurrentWord))
               End If

            Case %IDT_Current
               StopTalking = 0
               SetStatusBar
               Highlight CurrentLine
               SayText((CurrentWord))

            Case %IDT_Previous
               If CurrentLine = 0 Then
                  SayText "No previous word."
               Else
                  StopTalking = 0
                  Decr CurrentLine
                  Highlight CurrentLine
                  SetStatusBar
                  SayText((CurrentWord))
               End If

            Case %IDT_Last
               CurrentLine = WordCount - 1
               Highlight CurrentLine
               SetStatusBar
               SayText((CurrentWord))

            Case %IDT_Font
               SelectMainFont
               Control Set Font hDlg, %IDC_Words, hFont

            Case %IDT_Help       :
               temp$ = "http://www.garybeene.com/sw/gbsaylist.htm"
               iResult = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)
         End Select

      Case %WM_Notify
           nmtb = Cb.LParam
           Select Case @nmtb.hdr.Code
              Case %TBN_DROPDOWN
                 Select Case @nmtb.iItem
                    Case %IDT_Settings
                       Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                       Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                       Call TrackPopupMenu (hPopUpSettings, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                 End Select
           End Select

           Select Case Cb.NmId
               Case %IDT_First To %IDT_Help
                  Select Case Cb.NmCode
                     Case %TTN_GetDispInfo
                         P = Cb.LParam
                         @P.@lpszText = SetToolTips(Cb.NmId)
               End Select
           End Select
      Case %WM_Size
         Dialog Get Client hDlg To w,h
         Control Set Size hDlg, %IDC_Words, w-20,h-80
   End Select
End Function

Sub SaveSession
   Local temp$
   Control Get Text hDlg, %IDC_Words To temp$
   Open Exe.Path$ + "gbsaylist_wordlist.txt" For Output As #1
   Print #1, temp$;
   Close #1
End Sub

Sub LoadFile(fName$)
    Local temp$, tmp$, w,h As Long
    If IsFalse(IsFile(fName$)) Then
       Open fName$ For Output As #1
       Print #1, "Example words," + $CrLf + "including numbers." + _
                 $CrLf + "1.2" + $CrLf + "703.00" + $CrLf + "1023.44" + $CrLf + "42.50";
       Close #1
    End If
    Open fName$ For Binary As #1
    Get$ #1, Lof(1), temp$
    Close #1

    If Left$(temp$,11) = "gbSayListwh" Then 'file contains location where gbSayList should start
       tmp$ = Parse$(temp$,$CrLf,1)
       w = Val(Parse$(tmp$,$Spc,2))
       h = Val(Parse$(tmp$,$Spc,3))
       Dialog Set Loc hDlg, w+100,h+100
       Control Set Text hDlg, %IDC_Words, Mid$(temp$, InStr(temp$,$CrLf)+2)
    Else
       Control Set Text hDlg, %IDC_Words, temp$
    End If

End Sub

Sub Settings_INI(Task$)
   Local x As Long, y As Long
   Local xResult, yResult,temp,INIFileName As WStringZ*%Max_Path

   INIFileName = Exe.Path$ + "gbsaylist.ini"

   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "400", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "400", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "440", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "400", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height

      'get value for string variables
      Getprivateprofilestring "All", "UnitType", "Numbers", UnitType, %Max_Path, INIFileName
      Getprivateprofilestring "All", "FontName", "MS Sans Serif", FontName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "CurrentWord", "", CurrentWord, %Max_Path, INIFileName
      Getprivateprofilestring "All", "AllowedChars", Chr$(37,45,46,58,95,48 To 57,65 To 90,97 To 122), AllowedChars, %Max_Path, INIFileName

      'get value for numeric variables
      Getprivateprofilestring "All", "Delay", "0", temp, %Max_Path, INIFileName:  Delay = Val(temp)
      Getprivateprofilestring "All", "FontSize", "8", temp, %Max_Path, INIFileName:  FontSize = Val(temp)
      Getprivateprofilestring "All", "FontAttr", "0", temp, %Max_Path, INIFileName:  FontAttr = Val(temp)
      Getprivateprofilestring "All", "CurrentLine", "0", temp, %Max_Path, INIFileName:  CurrentLine = Val(temp)
      Getprivateprofilestring "All", "CaseSensitive", "0", temp, %Max_Path, INIFileName:  CaseSensitive = Val(temp)
      Getprivateprofilestring "All", "AutoSpeak", "0", temp, %Max_Path, INIFileName:  AutoSpeak = Val(temp)
      Getprivateprofilestring "All", "AutoClose", "0", temp, %Max_Path, INIFileName:  AutoClose = Val(temp)
      Getprivateprofilestring "All", "NotifyEnd", "0", temp, %Max_Path, INIFileName:  NotifyEnd = Val(temp)
   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "UnitType",UnitType, INIFileName
      WritePrivateProfileString "All", "FontName",FontName, INIFileName
      WritePrivateProfileString "All", "CurrentWord",CurrentWord, INIFileName
      WritePrivateProfileString "All", "AllowedChars",AllowedChars, INIFileName

      'save numeric variables
      WritePrivateProfileString "All", "Delay", (Str$(Delay)), INIFileName
      WritePrivateProfileString "All", "FontSize", (Str$(FontSize)), INIFileName
      WritePrivateProfileString "All", "FontAttr", (Str$(FontAttr)), INIFileName
      WritePrivateProfileString "All", "CurrentLine", (Str$(CurrentLine)), INIFileName
      WritePrivateProfileString "All", "CaseSensitive", (Str$(CaseSensitive)), INIFileName
      WritePrivateProfileString "All", "AutoSpeak", (Str$(AutoSpeak)), INIFileName
      WritePrivateProfileString "All", "AutoClose", (Str$(AutoClose)), INIFileName
      WritePrivateProfileString "All", "NotifyEnd", (Str$(NotifyEnd)), INIFileName
   End If
End Sub

Function NewProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x As Long, y As Long
   Select Case Msg
      Case %WM_LButtonUp, %WM_KeyUp
         SetStatusBar
      Case %WM_ContextMenu
         SetFocus wParam
         x = Lo(Integer,lParam) : y = Hi(Integer, lParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu hContext, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(OldProc&, hWnd, Msg, wParam, lParam)
End Function

Sub CreateContextMenu
   Menu New PopUp To hContext
   Menu Add String, hContext, "Copy",   %IDM_Copy,  %MF_Enabled
   Menu Add String, hContext, "Cut",    %IDM_Cut,  %MF_Enabled
   Menu Add String, hContext, "Paste",  %IDM_Paste,  %MF_Enabled
   Menu Add String, hContext, "Delete", %IDM_Delete,  %MF_Enabled
   Menu Add String, hContext, "-", 0, 0
   Menu Add String, hContext, "Clear", %IDM_Clear,  %MF_Enabled
   Menu Add String, hContext, "-", 0, 0
   Menu Add String, hContext, "Remove Blank Lines", %IDM_Blanks,  %MF_Enabled
   Menu Add String, hContext, "Create Word List", %IDM_Create,  %MF_Enabled
   Menu Add String, hContext, "-", 0, 0
   Menu Add String, hContext, "Sort Ascending", %IDM_SortA,  %MF_Enabled
   Menu Add String, hContext, "Sort Descending", %IDM_SortD,  %MF_Enabled
End Sub

Sub RemoveBlanks
   Local temp$, i As Long
   'put control content into array
   Control Get Text hDlg, %IDC_Words To temp$
   Control Send hDlg, %IDC_Words, %EM_GetLineCount, 0,0 To WordCount
   Dim WordList(WordCount-1) As String    'create array
   Parse temp$, WordList(), $CrLf         'put words into array

   'Trim$ each element of wordlist
   For i = 0 To UBound(WordList)
      WordList(i) = Trim$(WordList(i))
   Next i

   temp$ = Join$(WordList(),$CrLf)
   Replace $CrLf + $CrLf With $CrLf In temp$
   Control Set Text hDlg, %IDC_Words, Trim$(temp$,$CrLf)

End Sub

Sub SortWordList(Flag As Long)  '1=ascend  0=descend
   MousePtr 11
   Local temp$
   'put control content into array
   Control Get Text hDlg, %IDC_Words To temp$
   Control Send hDlg, %IDC_Words, %EM_GetLineCount, 0,0 To WordCount
   Dim WordList(WordCount-1) As String    'create array
   Parse temp$, WordList(), $CrLf         'put words into array

   'Sort array
   If Flag Then
      If CaseSensitive Then
         Array Sort WordList(), Ascend
      Else
         Array Sort WordList(), Collate UCase, Ascend
      End If
   Else
      If CaseSensitive Then
         Array Sort WordList(), Descend
      Else
         Array Sort WordList(), Collate UCase, Descend
      End If
   End If

   'Put array back into textbox
   Control Set Text hDlg, %IDC_Words, Join$(WordList(),$CrLf)
   MousePtr 1
End Sub

Sub CreateToolbar
    Local hImageList,hToolbar As Dword
    ImageList New Icon 24,24,24,10 To hImageList
    ImageList Add Icon hImageList, "speak"   '1
    ImageList Add Icon hImageList, "currentx"  '2
    ImageList Add Icon hImageList, "stopspeaking"  '3
    ImageList Add Icon hImageList, "firstitem"  '4
    ImageList Add Icon hImageList, "previousitem"  '5
    ImageList Add Icon hImageList, "nextitem"  '6
    ImageList Add Icon hImageList, "lastitem" '7
    ImageList Add Icon hImageList, "settings" '8
    ImageList Add Icon hImageList, "help" '9
    ImageList Add Icon hImageList, "fonttype" '10
    ImageList Add Icon hImageList, "paste" '11

    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0, %TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS
    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0     'default imagelist

    Toolbar Add Button  hDlg, %IDC_Toolbar, 1, %IDT_Play,  %TbStyle_Button, "Play"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 3, %IDT_Stop,  %TbStyle_Button, "Stop"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 11, %IDT_Paste,  %TbStyle_Button, "Paste"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 4, %IDT_First,  %TbStyle_Button, "First"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 5, %IDT_Previous,  %TbStyle_Button, "Prev"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 2, %IDT_Current,  %TbStyle_Button, "Current"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 6, %IDT_Next,  %TbStyle_Button, "Next"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 7, %IDT_Last,  %TbStyle_Button, "Last"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 10, %IDT_Font,  %TbStyle_Button, "Font"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 8, %IDT_Settings,  %TbStyle_Button Or %TbStyle_DropDown, "Settings"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 9, %IDT_Help,  %TbStyle_Button, "Help"

    Menu New PopUp To hPopupSettings
    Menu Add String, hPopupSettings, "Case Sensitive Sort", %IDM_Case,  %MF_Enabled
    Menu Add String, hPopupSettings, "AutoSpeak On Startup", %IDM_AutoSpeak,  %MF_Enabled
    Menu Add String, hPopupSettings, "AutoClose After Play", %IDM_AutoClose,  %MF_Enabled
    Menu Add String, hPopupSettings, "End of List Notification", %IDM_NotifyEnd,  %MF_Enabled
    Menu Add String, hPopupSettings, "-", 0,0
    Menu Add String, hPopupSettings, "Numbers", %IDM_Numbers, %MF_Enabled
    Menu Add String, hPopupSettings, "Dollars", %IDM_Dollars, %MF_Enabled
    Menu Add String, hPopupSettings, "-", 0,0
    Menu Add String, hPopupSettings, "No Pause Between Words", %IDM_0, %MF_Enabled
    Menu Add String, hPopupSettings, "2s Pause Between Words", %IDM_2, %MF_Enabled
    Menu Add String, hPopupSettings, "4s Pause Between Words", %IDM_4, %MF_Enabled
    Menu Add String, hPopupSettings, "6s Pause Between Words", %IDM_6, %MF_Enabled
End Sub

Function NumberToDollars(ByVal Number As Currency) As String
   Static Level      As Dword
   Local  Negative, dwCent   As Dword, sCent As String

   Incr Level
   If Level = 1 Then
      If Number < -922337203685477 Then 'If number is to big it will revert to -922337203685478
         NumberToDollars = "ERROR"
         Level = 0
         Exit Function
      End If
      If Number < 0 Then Negative = %TRUE
      dwCent = Abs(Frac(Number)) * 100
      sCent = " and " & Format$(Abs(dwCent),"00") & " CENT" & IIf$(dwCent > 1, "S ", "")
      sCent = "DOLLAR" & IIf$(Number <= -2 Or Number >= 2, "S", "") & sCent
      Number = Fix(Number)
   End If

   Select Case Number
      Case < 0
         Number = Abs(Number)
         NumberToDollars = "(MINUS) " & NumberToDollars(Number) & sCent
      Case 0
         If Level = 1 Then NumberToDollars = IIf$(Negative, "(MINUS) ", "") & "ZERO " & sCent
      Case < 20 '1 TO 19
         NumberToDollars = Choose$(Number, "ONE ", "TWO ", "THREE ", "FOUR " , "FIVE ", "SIX ", _
            "SEVEN ", "EIGHT ", "NINE ", "TEN ", "ELEVEN ", "TWELVE ", "THIRTEEN ", "FOURTEEN ", _
            "FIFTEEN ", "SIXTEEN ", "SEVENTEEN ", "EIGHTEEN ", "NINETEEN ") & sCent
      Case < 100 '20 TO 99
         NumberToDollars = Choose$(Number \ 10 - 1, "TWENTY", "THIRTY", "FORTY", _
            "FIFTY", "SIXTY", "SEVENTY", "EIGHTY", "NINETY") & _
            IIf$(Number Mod 10 <> 0, "-", " ") & NumberToDollars(Number Mod 10) & sCent
      Case < 1000 '100 TO 999
         NumberToDollars = NumberToDollars(Number \ 100) & "HUNDRED " & NumberToDollars(Number Mod 100) & sCent
      Case < 1000000 '1000 TO 999999
         NumberToDollars = NumberToDollars(Number \ 1000) & "THOUSAND " & NumberToDollars(Number Mod 1000) & sCent
      Case < 1000000000 '1000000 TO 999999999
         NumberToDollars = NumberToDollars(Number \ 1000000) & "MILLION " & NumberToDollars(Number Mod 1000000) & sCent
      Case < 1000000000000 '1000000000 TO 999999999999
         NumberToDollars = NumberToDollars(Number \ 1000000000) & "BILLION " & NumberToDollars(Number Mod 1000000000) & sCent
      Case <= 922337203685477
         NumberToDollars = NumberToDollars(Number \ 1000000000000) & "TRILLION " & NumberToDollars(Number Mod 1000000000000) & sCent
   End Select
   Decr Level
End Function

Sub SetMenuStatus
    Menu Set State hPopupSettings, ByCmd %IDM_Case, CaseSensitive * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDM_AutoSpeak, AutoSpeak * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDM_AutoClose, AutoClose * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDM_NotifyEnd, NotifyEnd * (%MFS_Checked Or %MFS_Enabled)

    Menu Set State hPopupSettings, ByCmd %IDM_Numbers, 0
    Menu Set State hPopupSettings, ByCmd %IDM_Dollars, 0
    Select Case UnitType
       Case "Numbers"   : Menu Set State hPopupSettings, ByCmd %IDM_Numbers, %MFS_Checked Or %MFS_Enabled
       Case "Dollars"   : Menu Set State hPopupSettings, ByCmd %IDM_Dollars, %MFS_Checked Or %MFS_Enabled
    End Select

    Menu Set State hPopupSettings, ByCmd %IDM_0, 0
    Menu Set State hPopupSettings, ByCmd %IDM_2, 0
    Menu Set State hPopupSettings, ByCmd %IDM_4, 0
    Menu Set State hPopupSettings, ByCmd %IDM_6, 0
    Select Case Delay
       Case 0    :  Menu Set State hPopupSettings, ByCmd %IDM_0, %MFS_Checked Or %MFS_Enabled
       Case 2000 :  Menu Set State hPopupSettings, ByCmd %IDM_2, %MFS_Checked Or %MFS_Enabled
       Case 4000 :  Menu Set State hPopupSettings, ByCmd %IDM_4, %MFS_Checked Or %MFS_Enabled
       Case 6000 :  Menu Set State hPopupSettings, ByCmd %IDM_6, %MFS_Checked Or %MFS_Enabled
    End Select

End Sub

Function SetToolTips(cID As Long) As String
   Select Case cID          'or this:   @P.hdr.idFrom
      Case %IDT_Play          : Function = "Speak the word list (starting at cursor)"
      Case %IDT_Pause         : Function = "Pause speaking"
      Case %IDT_Paste         : Function = "Paste clipboard into textbox"
      Case %IDT_Stop          : Function = "Stop speaking"
      Case %IDT_First         : Function = "Move to first item in list and speak that item"
      Case %IDT_Previous      : Function = "Move to previous item in list and speak that item"
      Case %IDT_Current       : Function = "Speak current item"
      Case %IDT_Next          : Function = "Move to next item in list and speak that item"
      Case %IDT_Last          : Function = "Move to last item in list and speak that item"
      Case %IDT_Settings      : Function = "Set delay to zero seconds"
      Case %IDT_Font          : Function = "Open Select Font dialog"
      Case %IDT_Help          : Function = "Open online help"
   End Select
End Function

Sub SelectMainFont
   Local fName As String, fPoints, fStyle, fColor, CharSet, Style As Long
   Style = %CF_ScreenFonts Or %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations 'Or IIf(FixedPitch,%CF_FixedPitchOnly,0)
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(FontDialogProc), GetModuleHandle(""), GetCurrentThreadId)
   Display Font hDlg, 100,100, FontName, FontSize, FontAttr, Style To fName, fPoints, fStyle, fColor, CharSet
   If Len(fName) Then
      FontName = fName : FontSize = fPoints : FontAttr = fStyle
      Font New FontName, FontSize, FontAttr To hFont
   End If
End Sub

Function FontDialogProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
    Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
    If nCode < 0 Then Exit Function
    If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
    If nCode = %HCBT_CREATEWND Then
        cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
        cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
        GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
        If UCase$(szTemp) = "#32770" Then @cst.cy = @cst.cy - 165 : @cst.cx = @cst.cx - 10  'dialog
    End If
End Function

Sub BuildAcceleratorTable
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(6)
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_T : ac(c).cmd   = %IDT_Play     : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_S : ac(c).cmd   = %IDT_Stop     : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_N : ac(c).cmd   = %IDT_Next     : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_W : ac(c).cmd   = %IDT_Current  : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_P : ac(c).cmd   = %IDT_Previous : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_F : ac(c).cmd   = %IDT_First    : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_L : ac(c).cmd   = %IDT_Last     : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Sub CreateWordList
   MousePtr 11
   Local delimiter$, temp$
   AllowedChars = Chr$(37,95,48 To 57,65 To 90,97 To 122)
   delimiter$ = Remove$(Chr$(0 To 255), Any AllowedChars)
   Control Get Text hDlg, %IDC_Words To temp$
   Backup$ = temp$
   If CaseSensitive = 0 Then temp$ = LCase$(Trim$(temp, Any delimiter$))
   ReDim WordList(ParseCount(temp$, Any delimiter$)-1) As String
   Parse temp$, WordList(), Any delimiter$
   If CaseSensitive Then
      Array Sort WordList(), Collate UCase
   Else
      Array Sort WordList()
   End If
   temp$ = Trim$(Join$(WordList(),$CrLf),$CrLf)  'Trim$ removes empty lines at start of list
   Control Set Text hDlg, %IDC_Words, temp$
   Control Set Focus hDlg, %IDC_Words
   MousePtr 1
End Sub

Sub SetStatusBar
   Local temp$, LineIndex, LineLength As Long
   Control Send hDlg, %IDC_Words, %EM_LineFromChar, -1, 0 To CurrentLine  'zero-based line number
   Control Send hDlg, %IDC_Words, %EM_GetLineCount, 0,0 To WordCount
   LineIndex  = SendMessage(hWords, %EM_LineIndex, CurrentLine, 0)  '1st char in LineNumber
   LineLength = SendMessage(hWords, %EM_LineLength, LineIndex, 0)  'length of line containing LineIndex
   temp = Space$(LineLength)
   SendMessageA(hWords, %EM_GetLine, CurrentLine, StrPtr(temp))     'get text, specified line
   CurrentWord = temp
   Statusbar Set Text hDlg, %IDC_StatusBar, 1, 0, "Line Count: " + Str$(WordCount) + Space$(8) _
         + "Current Line#: " + Str$(CurrentLine+1) + Space$(9) _
         + "Line Content: " + CurrentWord
End Sub

Sub Highlight(ByVal LineNumber As Long)
   Local StartPos, LineLength As Long
   StartPos = SendMessage(hWords, %EM_LineIndex, LineNumber, 0)    'pos of 1st char in lineM
   LineLength = SendMessage(hWords, %EM_LineLength, StartPos, 0)   'length of line containing 1st char
   SendMessage hWords, %EM_SetSel, StartPos, StartPos + LineLength 'select character rangeEnd Sub
   SendMessage hWords, %EM_ScrollCaret, 0, 0
End Sub

Thread Function SayList(ByVal Flag As Dword) As Dword
   Local vRes, vTxt, vTime As Variant, oSp As Dispatch, temp$
   Local iLine,iResult,StartPos,EndPos,LineLength,LineIndex As Long

   'say one word at a time, with delay

   'if there is a selection, then say it only
   SendMessage hWords, %EM_GetSel, VarPtr(StartPos), VarPtr(EndPos)  'cursor is here
   If StartPos = EndPos Then
      StartPos = CurrentLine
      EndPos = WordCount-1
   Else
      StartPos = SendMessage(hWords,%EM_LineFromChar,StartPos,0)
      EndPos   = SendMessage(hWords,%EM_LineFromChar,EndPos,0)
   End If

   For iLine = StartPos To EndPos
      'select line being spoken
      LineIndex  = SendMessage(hWords, %EM_LineIndex, iLine, 0)         'pos of 1st char in lineM
      LineLength = SendMessage(hWords, %EM_LineLength, LineIndex, 0)   'length of line containing 1st char
      SendMessage hWords, %EM_SetSel, LineIndex, LineIndex + LineLength 'select character rangeEnd Sub
      SendMessage hWords, %EM_ScrollCaret, 0, 0
      temp$ = Space$(LineLength)
      SendMessageA(hWords, %EM_GetLine, iLine, StrPtr(temp$))     'get text, specified line
      Statusbar Set Text hDlg, %IDC_StatusBar, 1, 0, "Line Count: " + Str$(WordCount) + Space$(8) _
            + "Current Line#: " + Str$(CurrentLine+1) + Space$(9) _
            + "Content: " + temp$  'Left$(NewWord,LineLength)

      'skip empty lines
      If Len(Trim$(temp$))=0 Then Iterate For

      'words starting with number are spoken differently
      If (UnitType="Dollars") And InStr("0123456789-",Left$(temp$,1)) Then
         SayText NumberToDollars(Val(Left$(temp$,LineLength)))
      Else
         SayText Left$(temp$,LineLength)
      End If

      If iLine <> EndPos Then Sleep Delay  'no delay after last item spoken
      If StopTalking Then Flag = 1 : Exit For
   Next i

   If NotifyEnd Then SayText(IIf$(Flag,"Cancelled.","No more items."))

End Function

Sub SayText (sText As WStringZ*%Max_Path)
   Local vRes, vTxt, vTime As Variant, oSp As Dispatch
   Let oSp = NewCom "SAPI.SpVoice"
   If IsFalse IsObject(oSp) Then Exit Sub
   vTxt = sText
   Object Call oSp.Speak(vTxt) To vRes
   vTime = -1 As Long
   Object Call oSp.WaitUntilDone(vTime) To vRes
End Sub
